#include "config.h"
#include "system.h"
#include "rtl.h"
#include "regs.h"
#include "hard-reg-set.h"
#include "real.h"
#include "insn-config.h"
#include "conditions.h"
#include "insn-attr.h"
#include "flags.h"
#include "recog.h"
#include "tree.h"
#include "output.h"
#include "expr.h"
#include "obstack.h"
#include "except.h"
#include "function.h"
#include "tm_p.h"
#include "target.h"
#include "target-def.h"

// TARGET_INITIALIZER̒ŎgĂ݂B
// ftHgł HI_OP=.short SI_OP=.long ƒ`Ă邪A
// C33MIPS  HI_OP=.half  SI_OP=.word Ȃ̂ŁA`ȂB
// x[XɂFR30ł܂܍Ē`Ă̂ŋCt܂B
#undef TARGET_ASM_ALIGNED_HI_OP
#define TARGET_ASM_ALIGNED_HI_OP	"\t.half\t"
#undef TARGET_ASM_ALIGNED_SI_OP
#define TARGET_ASM_ALIGNED_SI_OP	"\t.word\t"
struct gcc_target targetm = TARGET_INITIALIZER;	// K{I

// ̃W[Ŏgp}NłB
#define WORD_ALIGN(SIZE)	(((SIZE) + 3) & ~3)

struct c33_frame_info {
  unsigned int total_size;	/* # Bytes that the entire frame takes up. */
  unsigned int pretend_size;	/* # Bytes we push and pretend caller did. */
  unsigned int args_size;	/* # Bytes that outgoing arguments take up. */
  unsigned int reg_size;	/* # Bytes needed to store regs. */
  unsigned int var_size;	/* # Bytes that variables take up. */
  unsigned int frame_size;      /* # Bytes in current frame.  */
  unsigned int gmask;		/* Mask of saved registers. */
  unsigned int save_fp;		/* Nonzero if frame pointer must be saved. */
  int          initialized;	/* Nonzero if frame size already calculated. */
};
static struct c33_frame_info 	current_frame_info;

//܂gĂ܂BƂŃv[OEGs[OR[h̐ƂɎg܂B
void
c33_compute_frame_size()
{
	int regno;
	unsigned int var_size;
	unsigned int args_size;
	unsigned int pretend_size;
	unsigned int reg_size;
	unsigned int gmask;

	var_size     = WORD_ALIGN(get_frame_size());			// [Jϐ̈
	args_size    = WORD_ALIGN(current_function_outgoing_args_size);	// ö͈iX^bNnɂȂ镪j
	pretend_size = current_function_pretend_args_size;		// ȂɂHHH

	reg_size     = 0;	// WX^ޔ̈
	gmask        = 0;	// WX^ޔ}[N

	// SẴn[hEFAWX^𑖍āc
	for(regno = 0; regno < FIRST_PSEUDO_REGISTER; regno ++) {
		if(regno == FRAME_POINTER_REGNUM) continue;	// t[|C^͉ŕʏ
		// ޔKvȂi̔fGCCĂ݂jc
		if( regs_ever_live[regno] &&		// ֐ŎgĂāA
		   !call_used_regs[regno]) {		// ֐ĂяoŕۑȂĂWX^łȂ΁A
			reg_size += UNITS_PER_WORD;	// ޔ̈𑝂₵āA
			gmask |= 1 << regno;		// ۑ邱Ƃ}[NB
		}
	}

	// t[|C^gĂ邩A܂͕K{ȂAt[|C^ޔB
	current_frame_info.save_fp = (regs_ever_live[FRAME_POINTER_REGNUM] || frame_pointer_needed);
	reg_size += current_frame_info.save_fp * UNITS_PER_WORD;

	// X^bNt[ۑB
	current_frame_info.pretend_size = pretend_size;
	current_frame_info.var_size     = var_size;
	current_frame_info.args_size    = args_size;
	current_frame_info.reg_size     = reg_size;
	current_frame_info.frame_size   = args_size + var_size;
	current_frame_info.total_size   = args_size + var_size + reg_size + pretend_size;
	current_frame_info.gmask        = gmask;
	current_frame_info.initialized  = 1;
}

//zgɑSs\BǂʂŎĝ킩܂B
int
c33_num_arg_regs (int_mode, type)
     int int_mode;
     tree type;
{
  enum machine_mode mode = (enum machine_mode) int_mode;
  int size;

  if (MUST_PASS_IN_STACK (mode, type))
    return 0;

  if (type && mode == BLKmode)
    size = int_size_in_bytes (type);
  else
    size = GET_MODE_SIZE (mode);

  return (size + UNITS_PER_WORD - 1) / UNITS_PER_WORD;
}

//print_operandprint_operand_addressǂŌĂѕ̂悭킩Ȃc
void
c33_print_operand(FILE* fp,  rtx x, int code)
{
	rtx x0;

	// ܂̂ƂA"%+R[h+l"`͎gĂ܂BiF"%x0"j
	// "%+l"`݂̂łBiF"%0"j
	// O҂̌`g悤ɂȂƂɂȂƂ܂B
	if(code != 0) {
		fprintf(stderr, "unknown code = %x\n", code);
		output_operand_lossage("c33_print_operand: unknown code");
		abort();
	}

	switch(GET_CODE(x)) {
	case REG:
		if((unsigned)REGNO(x) >= ARRAY_SIZE(reg_names)) abort();
		fputs(reg_names [REGNO(x)], fp);
		return;
	case MEM:
		x0 = XEXP(x, 0);
		switch(GET_CODE(x0)) {
		case REG:
			if((unsigned)REGNO(x0) >= ARRAY_SIZE(reg_names)) abort();
			fprintf(fp, "[%s]", reg_names[REGNO(x0)]);
			return;
		case PLUS:
			if(GET_CODE(XEXP(x0, 0)) != REG
			|| GET_CODE(XEXP(x0, 1)) != CONST_INT) {
				fprintf(stderr, "bad INDEXed address:");
				debug_rtx(x);
				output_operand_lossage("c33_print_operand: unhandled MEM");
				abort();
			}
			if((unsigned)REGNO(XEXP(x0, 0)) >= ARRAY_SIZE(reg_names)) abort();
			fprintf(fp, "[%s+%d]", reg_names[REGNO(XEXP(x0, 0))], INTVAL(XEXP(x0, 1)));
			return;
		case SYMBOL_REF:
			output_address(x0);
			return;
		default:
			fprintf(stderr, "bad MEM code = %x\n", GET_CODE(x0));
			debug_rtx(x);
			output_operand_lossage("c33_print_operand: unhandled MEM");
			abort();
		}
		break;
	default:
		output_addr_const(fp, x);
		break;
	}
}

void
c33_print_operand_address(FILE* fp, rtx addr)
{
	switch(GET_CODE(addr)) {
	case SYMBOL_REF:
		output_addr_const(fp, addr);
		break;
	default:
		fprintf(stderr, "code = %x\n", GET_CODE(addr));
		debug_rtx(addr);
		output_operand_lossage("c33_print_operand_address: unhandled addr");
		abort();
	}
}

#define MUST_SAVE_REGISTER(regno)								\
	(regno == FRAME_POINTER_REGNUM) ? (regs_ever_live[regno] || frame_pointer_needed  )	\
	                                : (regs_ever_live[regno] && !call_used_regs[regno])

void
c33_expand_prologue()
{
	int regno, size;

	/* WX^ޔBipushnRTXev[g̏킩Ȃ̂ŁAdȂЂƂÂj */
	for(regno = 0; regno <= FIRST_PSEUDO_REGISTER - 1; regno++) {
		if(MUST_SAVE_REGISTER(regno)) {
			emit_insn(gen_subsi3(stack_pointer_rtx, stack_pointer_rtx, GEN_INT(4)));
			emit_move_insn(gen_rtx_MEM(SImode, stack_pointer_rtx), gen_rtx_REG(SImode, regno));
		}
	}

	/* X^bN蓖āB */
	size = get_frame_size () + current_function_outgoing_args_size;
	if(size) emit_insn(gen_subsi3(stack_pointer_rtx, stack_pointer_rtx, GEN_INT(size)));

	/* t[|C^ݒB */
	if(frame_pointer_needed) emit_move_insn(frame_pointer_rtx, stack_pointer_rtx);
}

void
c33_expand_epilogue()
{
	int regno, size;

	/* X^bN|C^ݒB */
	if(frame_pointer_needed) emit_move_insn(stack_pointer_rtx, frame_pointer_rtx);

	/* X^bNJB */
	size = get_frame_size () + current_function_outgoing_args_size;
	if(size) emit_insn(gen_addsi3(stack_pointer_rtx, stack_pointer_rtx, GEN_INT(size)));

	/* WX^BipopnRTXev[g̏킩Ȃ̂ŁAdȂЂƂÂj */
	for(regno = FIRST_PSEUDO_REGISTER - 1; regno >= 0; regno--) {
		if(MUST_SAVE_REGISTER(regno)) {
			emit_move_insn(gen_rtx_REG(SImode, regno), gen_rtx_MEM(SImode, stack_pointer_rtx));
			emit_insn(gen_addsi3(stack_pointer_rtx, stack_pointer_rtx, GEN_INT(4)));
		}
	}

	/* "ret"B */
	emit_insn(gen_c33_ret());
}
